function initPrefs()
{
    var prefElements = document.getElementsByAttribute("prefstring", "*");
    for (var i=0; i<prefElements.length; i++ )
    {
        var prefstring    = prefElements[i].getAttribute("prefstring");
        var prefid        = prefElements[i].getAttribute("id");
        var preftype      = prefElements[i].getAttribute("preftype");
        var prefdefval    = prefElements[i].getAttribute("prefdefval");
        var prefattribute = prefElements[i].getAttribute("prefattribute");
        var elt           = prefElements[i].localName;

        if (!preftype)
            preftype = getPreftype(elt);
        if (preftype == "int")
            prefdefval = parseInt(prefdefval, 10);
        if (!prefattribute)
            prefattribute = getPrefattribute(elt);

        var prefvalue;
        switch (preftype)
        {
            case "bool":
                prefvalue = nsPreferences.getBoolPref(prefstring, prefdefval);
                break;
            case "int":
                prefvalue = nsPreferences.getIntPref(prefstring, prefdefval);
                break;
            default:
                prefvalue = nsPreferences.copyUnicharPref(prefstring, prefdefval);
                break;
        }
        if (elt == "radiogroup")
            document.getElementById(prefid).selectedIndex = prefvalue
        else
            prefElements[i].setAttribute(prefattribute, prefvalue);
    }
}


function savePrefs()
{
    var prefElements = document.getElementsByAttribute("prefstring", "*");
    for (var i=0; i<prefElements.length; i++ )  
    {
        var prefstring    = prefElements[i].getAttribute("prefstring");
        var prefid        = prefElements[i].getAttribute("id");
        var preftype      = prefElements[i].getAttribute("preftype");
        var prefattribute = prefElements[i].getAttribute("prefattribute");
        var elt           = prefElements[i].localName;

        if (!preftype)
            preftype = getPreftype(elt);
        if (!prefattribute)
            prefattribute = getPrefattribute(elt);

        if (elt == "radiogroup")
            var prefvalue = document.getElementById(prefid).selectedIndex;
        else if (elt == "textbox")
            var prefvalue = document.getElementById(prefid).value;
        else
            var prefvalue = prefElements[i].getAttribute(prefattribute);

        if (preftype == "bool")
        prefvalue = prefvalue == "true" ? true : false;

        switch (preftype)
        {
            case "bool":
                nsPreferences.setBoolPref(prefstring, prefvalue);
                break;
            case "int":
                nsPreferences.setIntPref(prefstring, prefvalue);
                break;
            default:
                nsPreferences.setUnicharPref(prefstring, prefvalue);
                break;
        }
    }
}


function getPreftype(elem)
{
    var result = "";

    if (elem == "textbox")
        result = "string";
    else if (elem == "checkbox" || elem == "listitem" || elem == "button")
        result = "bool";
    else if (elem == "radiogroup" || elem == "menulist")
        result = "int";
    return result;
}


function getPrefattribute(elem)
{
    var result = "";

    if (elem == "radiogroup")
        result = "selectedIndex";
    else if (elem == "textbox" || elem == "menulist")
        result = "value";
    else if (elem == "checkbox" || elem == "listitem")
        result = "checked";
    else if (elem == "button")
        result = "disabled";
    return result;
}
